require "Unit"
require "GameLib"
require "Apollo"

local TargetFocus = {} 

function TargetFocus:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

	-- vars
	o.targets = {}

    return o
end

function TargetFocus:Init()
	Apollo.RegisterSlashCommand("targetfocus", "OnTargetFocusOn", self)
	
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)

	--	Slash Target support
	Apollo.RegisterSlashCommand("target", "OnSlashTarget", self)
	Apollo.RegisterSlashCommand("tar", "OnSlashTarget", self)
	Apollo.RegisterEventHandler("UnitCreated", "OnUnitCreated", self)
	Apollo.RegisterEventHandler("UnitDestroyed", "OnUnitDestroyed", self)
	-- End Slash Target
end

function TargetFocus:OnTargetFocusOn()

	local unitPlayer = GameLib.GetPlayerUnit()
	local unitToT = unitPlayer:GetAlternateTarget()
	
	if unitToT == nil then
		return
	end
	
	GameLib.SetTargetUnit(unitToT)
	
end

local TargetFocusInst = TargetFocus:new()
TargetFocusInst:Init()


-- Slash Target support
function TargetFocus:OnUnitCreated(unit)
	if not unit then return end
	table.insert(self.targets, { unit = unit, name = string.lower(unit:GetName()) })
	--Print(unit:GetName());
end

function TargetFocus:OnUnitDestroyed(unit)
	if not unit then return end
	for i, u in ipairs(self.targets) do
		if u.unit == unit then
			table.remove(self.targets, i)
			break
		end
	end
end

function TargetFocus:OnSlashTarget(cmd, ...)
	local query = string.lower(table.concat(arg, " "))
	
	for i, u in ipairs(self.targets) do
		-- lets look for a full match first
		if u.name == query then
			--Print(u.name);
			GameLib.SetTargetUnit(u.unit)
			target = GameLib.GetTargetUnit()
			
			if (target == u.unit) then 
				target:ShowHintArrow()
				return true
			end
		end
	end
	
	Print("Target Not Found");
	
end
-- End Slash Target